#include <vector>
#include <sstream>
#include <iostream>
#include <cmath>
#include "filtroCpp.h"
#include "filtro.h"

using namespace std;
#define forn(i,n) for(int i = 0 ; i < (int) (n); i++)
#define forsn(i,s,n) for(int i = (s) ; i < (int) (n); i++)
std::vector<std::vector<char> > centro(0);
std::vector<std::vector<char> > ImgAux(0);

void bordesCanny(IplImage * frame, bool ByN, bool binario)
{
	if (!ByN)
		BlackAndWhite(frame);
	int h = (*frame).height;
	int w = (*frame).width;	
	vector<unsigned char> Egra(h*(*frame).widthStep);
	vector<unsigned char> Emag(h*(*frame).widthStep);


	int movx[9] = {-1,-1,-1,0,0,0,1,1,1};
	int movy[9] = {0,-1,1,0,-1,1,0,-1,1};
	int valorH[9] = {-2,-1,-1,0,0,0,2,1,1};
	int valorV[9] = {0,-1,1,0,-2,2, 0,-1,1};

	for(int i= 1 ; i< (w-1)  ; i++)
	{
		for(int j = 1 ; j < h-1 ; j ++)
		{
			int valH = 0;
			int valV = 0;
			for(int k = 0; k < 9;k++)
			{
				valH+= ((unsigned char)(*frame).imageData[(j+movy[k])*(*frame).widthStep+(i+movx[k])*3]) * valorH[k];
				valV+= ((unsigned char)(*frame).imageData[(j+movy[k])*(*frame).widthStep+(i+movx[k])*3]) * valorV[k];
			}
			int val = abs(valH) + abs(valV) ;
			if (val > 255) val = 0;
			//if (val < 30) val = 0;
			Emag[(j)*(*frame).widthStep+i*3]= val;

			unsigned char aux = 0;
			if (valH*1000 > valV*-425 && valH*1000 < valV * 425)
				aux = 4;
			if (valH*1000 <valV*-425 && valH*1000 < valV *-2425)
				aux = 7;
			if (valH*1000 >valV*425 && valH*1000 < valV *2425)
				aux = 8;
			
			Egra[(j)*(*frame).widthStep+i*3]= aux;
		}
	}
	for(int i= 1 ; i< (w-1)  ; i++)
	{
		for(int j = 1 ; j < h-1 ; j ++)
		{			
			int k = Egra[(j)*(*frame).widthStep+i*3];			
			if (Emag[(j)*(*frame).widthStep+i*3] < Emag[(j+movy[k])*(*frame).widthStep+(i+movx[k])*3] || Emag[(j)*(*frame).widthStep+i*3] < Emag[(j+movy[k]*-1)*(*frame).widthStep+(i+movx[k]*-1)*3])
			{
				(*frame).imageData[j*(*frame).widthStep+i*3] = 0;	
				(*frame).imageData[j*(*frame).widthStep+i*3+1] = 0;	
				(*frame).imageData[j*(*frame).widthStep+i*3+2] = 0;	
				(*frame).imageData[j*(*frame).widthStep+i*3+3] = 0;	
			}
			else
			{
				(*frame).imageData[j*(*frame).widthStep+i*3] = Emag[(j)*(*frame).widthStep+i*3];	
				(*frame).imageData[j*(*frame).widthStep+i*3+1] = Emag[(j)*(*frame).widthStep+i*3];	
				(*frame).imageData[j*(*frame).widthStep+i*3+2] = Emag[(j)*(*frame).widthStep+i*3];	
			}

		}
	}
	if (binario)
		fotoBinaria(frame);



	return;

}


void CambiarFrameAUnaSeccion(IplImage * frame, int h,int w,char* comienzo,int seccion)
{	
	(*frame).height = h /3;
	(*frame).width = w / 3;
	char* base = comienzo + (seccion / 3) * (*frame).widthStep * (*frame).height;
	seccion = seccion %3;
	base = base + seccion * (*frame).width * 3;
	(*frame).imageData = base;
}
void todasJuntas(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;	
	char*comienzo = (*frame).imageData;
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,0);
	BlackAndWhite(frame);
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,1);
	invertir(frame);		
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,6);
	bordesSimples(frame);
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,7);
	bordesSobel(frame);
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,2);
	fotoBinaria(frame);
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,3);
	zoom(frame);
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,5);
	filtroGauseano(frame, false);
	CambiarFrameAUnaSeccion(frame,h,w,comienzo,8);
	bordesCanny(frame, false,false);



	(*frame).height = h;
	(*frame).width = w;
	(*frame).imageData = comienzo;

	return;
}

void filtroGauseano(IplImage * frame, bool ByN)
{
	int movx[25] = {-1,-1,-1,0,0,0,1,1,1,
					-2,-2,-2,-2,-2,
					2,2,2,2,2,
					-1,-1,1,1,0,0};
	int movy[25] = {0,-1,1,0,-1,1,0,-1,1,
					-2,-1,0,1,2,
					-2,-1,0,1,2,
					-2,2,-2,2,-2,2};
	int valores[25] = {26,16,16,41,26,26,26,16,16,
					1,4,7,4,1,
					1,4,7,4,1,
					4,4,4,4,7,7};
	//BlackAndWhite(frame);

	int h = (*frame).height;
	int w = (*frame).width;	
	if (!ByN)
	{
		for(int i= 2 ; i< (w-2)*3 ; i++)
		{
			for(int j = 2 ; j < h-2 ; j ++)
			{
				int sum = 0;
				forn(k,25)
				{
					sum+= (int)((unsigned char)(*frame).imageData[(j+movx[k])*(*frame).widthStep+(i+movy[k]*3)] )*valores[k];
				}
				(*frame).imageData[j*(*frame).widthStep+i] = sum/ 273;
			}
		}
		return;
	}
	for(int i= 2 ; i< (w-2) ; i++)
	{
		for(int j = 2 ; j < h-2 ; j ++)
		{
			int sum = 0;
			forn(k,25)
			{
				sum+= (int)((unsigned char)(*frame).imageData[(j+movx[k])*(*frame).widthStep+(i+movy[k])*3] )*valores[k];
			}
			(*frame).imageData[j*(*frame).widthStep+i*3+1] = sum/ 273;
		}
	}
	for(int i= 2 ; i< w-2 ; i++)
	{
		for(int j = 2 ; j < h-2 ; j ++)
		{
			(*frame).imageData[j*(*frame).widthStep+i*3] = (*frame).imageData[j*(*frame).widthStep+i*3+1];			 
			(*frame).imageData[j*(*frame).widthStep+i*3+2] =(*frame).imageData[j*(*frame).widthStep+i*3+1];
		}
	}
}

void fotoBinaria(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;
	double corte  = 0;
	
	double cortenuevo = 150;
	while (abs(corte - cortenuevo) > 1)
	{
		corte = cortenuevo;
		int sumtecho = 0;
		int sumpiso = 0;
		int cantecho = 0;
		int canpiso = 0;
		for(int i= 0 ; i< w ; i++)
		{
			for(int j = 0 ; j < h ; j ++)
			{
				int aux = 0;
				aux += ((unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3] ) ;
				aux += ((unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3+1]) ;
				aux += ((unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3+2]) ;
				if (corte > aux)
				{
					cantecho++;
					sumtecho +=aux;
				}
				else
				{
					canpiso++;
					sumpiso += aux;
				}
			
			}
		}
		cortenuevo = ((double)sumpiso / (double)canpiso + (double)sumtecho / (double)cantecho)/2;
	}
	for(int i= 0 ; i< w ; i++)
		{
			for(int j = 0 ; j < h ; j ++)
			{
				double suma = 0;
				suma += ((unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3] ) ;
				suma += ((unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3+1]) ;
				suma += ((unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3+2]) ;
			
				if (suma > corte)
				{
					(*frame).imageData[j*(*frame).widthStep+i*3] = (unsigned char)255;
					(*frame).imageData[j*(*frame).widthStep+i*3+1] = (unsigned char)255;
					(*frame).imageData[j*(*frame).widthStep+i*3+2] = (unsigned char)255;
				}
				else
				{
				
					(*frame).imageData[j*(*frame).widthStep+i*3] = (unsigned char)0;
					(*frame).imageData[j*(*frame).widthStep+i*3+1] = (unsigned char)0;
					(*frame).imageData[j*(*frame).widthStep+i*3+2] = (unsigned char)0;
				}
			}
		}

}

void zoom(IplImage * frame)
{
	
	int h = (*frame).height;
	int w = (*frame).width;
	if ((int)centro.size() < w/2*3)
		centro.resize(w/2*3);
	if ((int)centro[0].size() < h/2)
	{
		forn(i,centro.size())
			centro[i].resize( h/2);
	}

	for(int i= w/2-w/4 ; i< w/2+w/4 ; i++)
	{
		for(int j = h/2-h/4 ; j < h/2+h/4 ; j ++)
		{
			centro[(i-(w/2-w/4))*3][j-(h/2-h/4)] = (*frame).imageData[j*(*frame).widthStep+i*3];
			centro[(i-(w/2-w/4))*3+1][j-(h/2-h/4)] = (*frame).imageData[j*(*frame).widthStep+i*3+1];
			centro[(i-(w/2-w/4))*3+2][j-(h/2-h/4)] = (*frame).imageData[j*(*frame).widthStep+i*3+2];
		}
	}
	for(int i= 0 ; i< w/2 ; i++)
	{
		for(int j = 0 ; j < h/2 ; j ++)
		{
			int pixel[4] = {j*2*(*frame).widthStep+i*2*3,
							j*2*(*frame).widthStep+i*2*3+3,
							(j*2+1)*(*frame).widthStep+i*2*3,
							(j*2+1)*(*frame).widthStep+i*2*3+3};
			forn(k,4)
			{
				(*frame).imageData[pixel[k]] = centro[i*3][j];
				(*frame).imageData[pixel[k]+1] = centro[i*3+1][j];
				(*frame).imageData[pixel[k]+2] = centro[i*3+2][j];
			}
		}
	}
}

void bordesSobel(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;
	int ws = (*frame).widthStep;
//	int movx[9] =   {-1,-1,-1,0, 0,0, 1, 1,1};
//	int movx[9] =   {-3,-3,-3,0, 0,0, 3, 3,3};
//	int movy[9] =  { 0,-ws, ws,0,-ws,ws, 0,-ws,ws};
//	int movy[9] =   { 0,-1, 1,0,-1,1, 0,-1,1};
//	int valorH[9] = {-2,-1,-1,0, 0,0, 2, 1,1};
//	int valorV[9] = { 0,-1, 1,0,-2,2, 0,-1,1};
//	int valorH[9] = { 0, 0, 0, 0, 0, 0, 0, 0, 0};
//	int valorV[9] = {-1,-1,-1,-1,-1,8,-1,-1,-1};
	if ((int)ImgAux.size() <  w*3)
		ImgAux.resize(w*3);
	if ((int)ImgAux[0].size() < h)
	{
		forn(i,ImgAux.size())
			ImgAux[i].resize(h);
	}
	
	unsigned char *I = (unsigned char*)(*frame).imageData;
	for(int j = 1 ; j < h-1 ; j ++)
	{
		int y = j *ws;
		for(int i= 1 ; i< (w-1) *3 ; i++)
		{
			int valH = 0;
			int valV = 0;
			/*for(int k = 0; k < 9;k++)
			{
				valH+= ((unsigned char)(*frame).imageData[y+movy[k]+(i+movx[k])]) * valorH[k];
				valV+= ((unsigned char)(*frame).imageData[y+movy[k]+(i+movx[k])]) * valorV[k];
			}*/
			valH+= (I[y+0*ws+(i-3)]) * -2;
			valV+= (I[y+0*ws+(i-3)]) * 0;

			valH+= (I[y+1*ws+(i-3)]) * -1;
			valV+= (I[y+1*ws+(i-3)]) * 1;
						
			valH+= (I[y-1*ws+(i-3)]) * -1;
			valV+= (I[y-1*ws+(i-3)]) * -1;
												
			valH+= (I[y+1*ws+(i)]) * 0;
			valV+= (I[y+1*ws+(i)]) * 2;
						
			valH+= (I[y-1*ws+(i)]) * 0;
			valV+= (I[y-1*ws+(i)]) * -2;
						
			valH+= (I[y+0*ws+(i+3)]) * 2;
			valV+= (I[y+0*ws+(i+3)]) * 0;
						
			valH+= (I[y-1*ws+(i+3)]) * 1;
			valV+= (I[y-1*ws+(i+3)]) * -1;

			valH+= (I[y+1*ws+(i+3)]) * 1;
			valV+= (I[y+1*ws+(i+3)]) * 1;
			int val = abs(valH) + abs(valV) ;
			if (val > 255) val = 255;
			ImgAux[i][j]= val;
		}
	}
	for(int i= 1 ; i< (w-1)*3 ; i++)	
		for(int j = 1 ; j < h-1 ; j ++)		
			(*frame).imageData[j*(*frame).widthStep+i] = ImgAux[i][j];

}






void bordesSimples(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;
	//int movx[4] = {-1,1,0,0};
	//int movy[4] = {0,0,-1,1};
	for(int j = 1 ; j < h-1 ; j ++)
	{
		int y = j*(*frame).widthStep;
		for(int i= 1 ; i< w -1; i++)
		{
		
			//bool borde = false;
			int sum  = 0;
			//derecha
			sum += abs((unsigned char)(*frame).imageData[y+i*3] - (unsigned char)(*frame).imageData[y+i*3+3]);
			sum += abs((unsigned char)(*frame).imageData[y+i*3+1] -(unsigned char) (*frame).imageData[y+i*3+3+1]);
			sum += abs((unsigned char)(*frame).imageData[y+i*3+2] - (unsigned char)(*frame).imageData[y+i*3+3+2]);
			//abajo
			sum += abs((unsigned char)(*frame).imageData[y+i*3] - (unsigned char)(*frame).imageData[y+(*frame).widthStep+i*3]);
			sum += abs((unsigned char)(*frame).imageData[y+i*3+1] -(unsigned char) (*frame).imageData[y+(*frame).widthStep+i*3+1]);
			sum += abs((unsigned char)(*frame).imageData[y+i*3+2] - (unsigned char)(*frame).imageData[y+(*frame).widthStep+i*3+2]);
			
			unsigned char val = sum;
			if (sum > 255)
				val = 255;
			(*frame).imageData[y+i*3+2] = val;
			(*frame).imageData[y+i*3+1] = val;
			(*frame).imageData[y+i*3] = val;

		}
	}
}







void BlackAndWhite(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;
	for(int j = 0 ; j < h ; j ++)
	{
		int y = j*(*frame).widthStep;
		for(int i= 0 ; i< w ; i++)
		{
			int sum  = 0;
			sum += ((unsigned char)(*frame).imageData[y+i*3] ) * 30;
			sum += ((unsigned char)(*frame).imageData[y+i*3+1])  * 59;
			sum += ((unsigned char)(*frame).imageData[y+i*3+2])  * 11;
			sum/=100;
			(*frame).imageData[y+i*3] = (sum);
			(*frame).imageData[y+i*3+1] = (sum);
			(*frame).imageData[y+i*3+2] = (sum);			
		}
	}
	// Rojo 30%, Verde 59%, Azul 11%
}
void invertir(IplImage *frame)
{
	int h = (*frame).height;
	int w = (*frame).width;

	
	for(int j = 0 ; j < h ; j ++)
	{
		int y = j*(*frame).widthStep;
		for(int i= 0 ; i< w*3; i++)
		{
			(*frame).imageData[y+i] = 255-(unsigned char)(*frame).imageData[y+i];
		}
	}
}

typedef unsigned char uchar;

void zoomBillinear(IplImage *frame)
{
	int h = frame->height;
	int w = frame->width;
    const int WS = frame->widthStep;
    uchar *auxBase = (uchar*)malloc(WS*h);
    memcpy(auxBase,frame->imageData,WS*h);
    const uchar *base = auxBase + 3*(w/4) + WS * (h/4);
    uchar *outputBase = (uchar*)frame->imageData;
    for(int i= 0 ; i< h/2 ; i++)
	{
        const uchar *centro = base;
        uchar *output = outputBase;
		for(int j = 0 ; j < w/2 ; j ++)
		{
            forn(col,3)
			{
                unsigned A = centro[0], B,C,D;
                // Superiores
                C = centro[-WS];
                // Superior izquierdo
                B = centro[-3];
                D = centro[-WS-3];
				output[0] = (9 * A + 3 * (B+C) + D) / 16;
                // Superior derecho
                B = centro[3];
                D = centro[-WS+3];
				output[3] = (9 * A + 3 * (B+C) + D) / 16;
                // Inferiores
                C = centro[WS];
                // Inferior izquierdo
                B = centro[-3];
                D = centro[WS-3];
				output[WS] = (9 * A + 3 * (B+C) + D) / 16;
                // Inferior derecho
                B = centro[3];
                D = centro[WS+3];
				output[WS+3] = (9 * A + 3 * (B+C) + D) / 16;
                
                centro++;
                output++;
			}
            output += 3;
		}
        base += WS;
        outputBase += 2*WS;
	}
    free(auxBase);
}

void duplicarContraste(IplImage *frame)
{
	int h = frame->height;
	int w = frame->width;
    const int WS = frame->widthStep;
    uchar *base = (uchar*)frame->imageData;
    unsigned xm[3] = {0,0,0};
    for(int i= 0 ; i< h ; i++)
	{
        const uchar *pos = base;
		for(int j = 0 ; j < w ; j ++)
		{
            forn(col,3)
                xm[col] += *pos++;
		}
        base += WS;
	}
    forn(col,3)
        xm[col] /= h*w;
    base = (uchar*)frame->imageData;
    for(int i= 0 ; i< h ; i++)
	{
        uchar *pos = base;
		for(int j = 0 ; j < w ; j ++)
		{
            forn(col,3)
            {
                int newCol = 2 * *pos - xm[col];
                if (newCol < 0) newCol = 0;
                if (newCol > 255) newCol = 255;
                *pos++ = newCol;
            }
		}
        base += WS;
	}
}

void colorBalance(IplImage *frame, unsigned c1, unsigned c2, unsigned c3)
{
	int h = frame->height;
	int w = frame->width;
    const int WS = frame->widthStep;
    uchar *base = (uchar*)frame->imageData;
    unsigned colorCoef[3] = {c1,c2,c3};
    for(int i= 0 ; i< h ; i++)
	{
        uchar *pos = base;
		for(int j = 0 ; j < w ; j ++)
		{
            forn(col,3)
            {
                int newCol = (colorCoef[col] * *pos ) / 128;
                if (newCol > 255) newCol = 255;
                *pos++ = newCol;
            }
		}
        base += WS;
	}
}

void bokeh(IplImage *frame, unsigned kernelSize)
{
	int h = frame->height;
	int w = frame->width;
    const int WS = frame->widthStep;
    uchar *aux = (uchar*)malloc(WS*h);
    memcpy(aux, frame->imageData, WS*h);
    unsigned *k = (unsigned *)malloc(kernelSize * sizeof(unsigned));
    unsigned AREA = 0;
    forn(i,kernelSize)
        AREA += 2 * (k[i] = sqrt(kernelSize * kernelSize - i*i)) - 1;
    AREA = AREA * 2 - (2 * k[0] - 1);
    
    uchar *output = (uchar*)frame->imageData;
    uchar *input = aux;
    for(int i= 0 ; i< h ; i++)
	{
        unsigned total[3] = {0,0,0};
        forsn(ip, max(-int(kernelSize)+1, -i), min(h-i,int(kernelSize)))
        {
            forn(j,k[abs(ip)])
            if (j < w)
            forn(col,3)
                total[col] += input[WS*ip + 3 * j + col];
        }
        
        // En este punto ya estan computados los totales iniciales.
        
        uchar *inputPos = input;
        uchar *outputPos = output;
		for(int j = 0 ; j < w ; j ++)
		{
            forn(col,3)
            {
                *outputPos++ = total[col] / AREA;
                // Quitar uno a izquierda, meter uno a derecha

                forsn(ip, max(-int(kernelSize)+1, -i), min(h-i,int(kernelSize)))
                {
                    const int D = k[abs(ip)];
                    if (j-D+1 >= 0)
                        total[col] -=  inputPos[WS*ip - 3*(D-1)];
                    if (j+D < w)
                        total[col] += inputPos[WS*ip + 3*D];
                }
                inputPos++;
            }
		}
        output += WS;
        input  += WS;
	}
    free(k);
    free(aux);
}

void nearestRot(IplImage *frame, float alpha)
{
    const float sinAlpha = sin(alpha);
    const float cosAlpha = cos(alpha);
	int h = frame->height;
	int w = frame->width;
    const int WS = frame->widthStep;
    uchar *aux = (uchar*)malloc(WS*h);
    memcpy(aux, frame->imageData, WS*h);    
    uchar *output = (uchar*)frame->imageData;
    const int cx = h/2, cy = w/2;
    for(int i= 0 ; i< h ; i++)
	{
        uchar *outputPos = output;
		for(int j = 0 ; j < w ; j ++)
		{
            const int ri = round(cx + cosAlpha * (i - cx) - sinAlpha * (j - cy) );
            const int rj = round(cy + sinAlpha * (i - cx) + cosAlpha * (j - cy) );
            if (0 <= ri && ri < h && 0 <= rj && rj < w)
                forn(col,3) *outputPos++ = aux[WS*ri+3*rj+col];
            else
                forn(col,3) *outputPos++ = 0;
		}
        output += WS;
	}
    free(aux);
}

void billinearRot(IplImage *frame, float alpha)
{
    const float sinAlpha = sin(alpha);
    const float cosAlpha = cos(alpha);
	int h = frame->height;
	int w = frame->width;
    const int WS = frame->widthStep;
    uchar *aux = (uchar*)malloc(WS*h);
    memcpy(aux, frame->imageData, WS*h);    
    uchar *output = (uchar*)frame->imageData;
    const int cx = h/2, cy = w/2;
    for(int i= 0 ; i< h ; i++)
	{
        uchar *outputPos = output;
		for(int j = 0 ; j < w ; j ++)
		{
            const float fri = cx + cosAlpha * (i - cx) - sinAlpha * (j - cy);
            const float frj = cy + sinAlpha * (i - cx) + cosAlpha * (j - cy);
            float ifri,ifrj;
            const float fracRI = modf(fri,&ifri);
            const float fracRJ = modf(frj,&ifrj);
            const int ri = ifri, rj = ifrj;
            if (0 <= ri && ri < h-1 && 0 <= rj && rj < w-1)
                forn(col,3) *outputPos++ = round(aux[WS*ri+3*rj+col] * (1.0 - fracRI) * (1.0 - fracRJ)
                                         + aux[WS*(ri+1)+3*rj+col] * fracRI * (1.0 - fracRJ)
                                         + aux[WS*ri+3*(rj+1)+col] * (1.0 - fracRI) * fracRJ
                                         + aux[WS*(ri+1)+3*(rj+1)+col] * fracRI * fracRJ);
            else
                forn(col,3) *outputPos++ = 0;
		}
        output += WS;
	}
    free(aux);
}

/*
void transpasarRojo(IplImage * frame)
{
	int h = (*frame).height;
	int w = (*frame).width;
	for(int i= 0 ; i< w ; i++)
	{
		for(int j = 0 ; j < h ; j ++)
		{
			bool rojo = false;
			double r = (unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3]*0.3;
			double g = (unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3+1]*0.59;
			double b = (unsigned char)(*frame).imageData[j*(*frame).widthStep+i*3+2]*0.11;
			
			if (r+g+b > 65 && r > 21)
			{
				if (b < 15)
				{
					if (g < 30)
						if (r*1.5 > g+b)
							rojo = true;
				}
			}
			if (i == w/2 && j ==  h /2)
			{
				//cout<<r<<" "<<g<< " " <<b<<endl;
			}

			if (rojo)
			{
				//cout<<"rojooo"<<endl;
				//(*frame).imageData[j*(*frame).widthStep+i*3+2] = frameVieja[j*(*frame).widthStep+i*3+2];
				//(*frame).imageData[j*(*frame).widthStep+i*3+1] = frameVieja[j*(*frame).widthStep+i*3+1];
				//(*frame).imageData[j*(*frame).widthStep+i*3] =	frameVieja[j*(*frame).widthStep+i*3];
			}
			

		}
	
	}
}*/
